/***************************************************************************
                          recordset.cpp  -  description
                             -------------------
    begin                : Mon Feb 14 2000
    copyright            : (C) 2000 by satish
    email                : 
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "recordset.h"
#include <iostream.h>
#include <string.h>


//------------------------------------------------------------

recordset::recordset(){
}
//------------------------------------------------------------

recordset::~recordset(){
}
//------------------------------------------------------------

void recordset::OpenRecordset(MYSQL *Structmysql, char *sql){

mysql=Structmysql;
strcpy(RecSource, sql);
//cerr << "Query: "<< RecSource << endl;

if (mysql_query(mysql, RecSource)==0){
	RecResult=mysql_store_result(mysql);
	if (RecResult==NULL){
		if (mysql_num_fields(mysql)==0){
			cerr << "Empty qry. No err" << endl;
			RecordCount=0;
			RowPtr=0;
		}
		else{
			cerr << "Empty qry. Err" << endl;
			RecordCount=0;
			RowPtr=0;
		}
	}
	else {
//		cerr << "Qry returned records" << endl;
		RecordCount=mysql_num_rows(RecResult);
		mysql_data_seek(RecResult, 0);
		RecRow=mysql_fetch_row(RecResult);
		FillCols();
		RowPtr=0;
		BOR=true;
		if (RecordCount==0)
			EOR=true;
		else
			EOR=false;
	}
}
else{
	cerr << "Error executing query" << endl;
}
}
//------------------------------------------------------------

void recordset::CloseRecordset(){
if (RecResult != NULL)
	mysql_free_result(RecResult);
}
//------------------------------------------------------------

void recordset::MoveFirst(){
RowPtr=0;
if (RecordCount==0){
	EOR=true;
	BOR=true;
	}
else{
	EOR=false;
	BOR=true;
	mysql_data_seek(RecResult, RowPtr);
	RecRow=mysql_fetch_row(RecResult);
	FillCols();
	}
}
//------------------------------------------------------------

void recordset::MoveLast(){
if (RecordCount==0){
	RowPtr=0;
	EOR=true;
	BOR=true;
	}
else{
	RowPtr=RecordCount-1;
	EOR=true;
	BOR=false;
  mysql_data_seek(RecResult, RowPtr);
	RecRow=mysql_fetch_row(RecResult);
	FillCols();
	}
}
//------------------------------------------------------------

void recordset::MoveNext(){
if (RecordCount==0){
	EOR=true;
	BOR=true;
	}
else{
	if (RowPtr < RecordCount-1){
		RowPtr++;
		EOR=false;
		BOR=false;
		mysql_data_seek(RecResult, RowPtr);
		RecRow=mysql_fetch_row(RecResult);
		FillCols();
		}
	else{
		EOR=true;
		BOR=false;
		mysql_data_seek(RecResult, RowPtr);
		RecRow=mysql_fetch_row(RecResult);
		FillCols();	
		}
	}
}
//------------------------------------------------------------

void recordset::MovePrevious(){
if (RowPtr > 0)
	RowPtr--;
if (RowPtr==0 && RecordCount==0){
	EOR=true;
	BOR=true;
	}
else{
	EOR=false;
	BOR=true;
	mysql_data_seek(RecResult, RowPtr);
	RecRow=mysql_fetch_row(RecResult);
	FillCols();
	}
}
//------------------------------------------------------------

char* recordset::GetFieldN(int FNum){
		return TFlds[FNum].CVal;
}
//------------------------------------------------------------

char* recordset::GetField(char* FName){
int i;

for (i=0; i<FieldCount; i++)
	if (strcmp(TFlds[i].CNam, FName)==0)
		return TFlds[i].CVal;
return "";
}
//------------------------------------------------------------

void recordset::SetFieldN(int FNum, char* Value){
TFlds[FNum].CVal=Value;
}
//------------------------------------------------------------

void recordset::SetField(char* FName, char *Value){
int i;

for (i=0; i<FieldCount; i++)
	if (strcmp(TFlds[i].CNam, FName)==0)
		TFlds[i].CVal= Value;
}
//------------------------------------------------------------

void recordset::FillCols(){
long i;

RecFields=mysql_fetch_fields(RecResult);
FieldCount=mysql_num_fields(RecResult);
for (i=0; i<FieldCount; i++){
	TFlds[i].CNam=RecFields[i].name;
	if (RecordCount==0)
		TFlds[i].CVal="NULL";
	else
		TFlds[i].CVal=RecRow[i];
	TFlds[i].CLen=RecFields[i].length;
	}
}
//------------------------------------------------------------

void recordset::Edit(){
Mode=MODE_EDIT;
}
//------------------------------------------------------------

void recordset::AddNew(){

Mode=MODE_ADD;
for (int i=0; i<FieldCount; i++)
	TFlds[i].CVal="";
}
//------------------------------------------------------------

void recordset::Update(char *Where){
char qry[MAX_ACTQRY_LEN];
int i;

switch (Mode){
	case MODE_RO:
		cerr << "Update without Edit or AddNew" << endl;
		break;
	
	case MODE_EDIT:
		strcpy(qry, "UPDATE ");
		strcat(qry, RecFields[0].table);
		strcat(qry, " SET ");
		for (i=0; i<FieldCount; i++){
  		strcat(qry, TFlds[i].CNam);
			strcat(qry, "='");
			strcat(qry, TFlds[i].CVal);
			strcat(qry, "'");
			if (i<FieldCount-1)
				strcat(qry, ",");
			}
		strcat(qry, " WHERE ");
		strcat(qry, Where);
//		cerr << "Uqry:" << qry << endl;
		ActionQry(qry);
		Mode=MODE_RO;
	  break;

	case MODE_ADD:
		strcpy(qry, "INSERT INTO ");
		strcat(qry, RecFields[0].table);
		strcat(qry, " SET ");
		for (i=0; i<FieldCount; i++){
  		strcat(qry, TFlds[i].CNam);
			strcat(qry, "='");
			strcat(qry, TFlds[i].CVal);
			strcat(qry, "'");
			if (i<FieldCount-1)
				strcat(qry, ",");
			}
//		cerr << "ANew:" << qry << endl;
		ActionQry(qry);
		Mode=MODE_RO;
    break;
	}
}
//------------------------------------------------------------

void recordset::Delete(char *Where){
char qry[MAX_ACTQRY_LEN];

strcpy(qry, "DELETE FROM ");
strcat(qry, RecFields[0].table);
if (strcmp(Where, "")!=0){
	strcat(qry, " WHERE ");
	strcat(qry, Where);
	}
//cerr << "Delqry:" << qry << endl;
ActionQry(qry);
}
//------------------------------------------------------------

void recordset::ActionQry(char *ActQry){
if (mysql_query(mysql, ActQry)){
	cerr << "Error running action query" << endl;	
	}
else{
	AffectedRows=mysql_affected_rows(mysql);
//	cerr << "Affected rows:" << AffectedRows << endl;
	}
}
//------------------------------------------------------------

void recordset::Refresh(){
unsigned long int i;

i=RowPtr;
CloseRecordset();
OpenRecordset(mysql, RecSource);
if (i>=RecordCount)
	RowPtr=RecordCount-1;
else
	RowPtr=i;
mysql_data_seek(RecResult, RowPtr);
RecRow=mysql_fetch_row(RecResult);
FillCols();
}
//------------------------------------------------------------
